#include <math.h>
#ifdef _LIB
#define LINKDLL 
#else 
#ifdef MATHADD
#define LINKDLL __declspec(dllexport)
#else
#define LINKDLL __declspec(dllimport)
#endif
#endif

//       

//Function of transformation of floating number as a whole with a rounding off
LINKDLL int Round(double x);

//   

//Set of functions of matrix algebra
class CMatrix
{
	public:
		double **matr;			//    m[][]
								//Pointer on array of type m[][]
		int m;					//  
								//Number of columns matrixes
		int n;					//  
								//Number of lines of a matrix
		bool bFlagDel;		 	//  
								//	     "false",
								//	      "matr"
								//	     .

								//The flag of clearing of memory
								// is established in the designer of a matrix equal "false",
								// if the memory, allocated with the designer, under a file "matr"
								// is transferred to other matrix before a call destructor.		
	public:
	// 
	//	m -   
	//	n -  
	//	bFl -   
	//	    
	//	       
	//	  error

	//The Designer of a class 	 
	// m - number of columns matrixes
	// n - number of lines 	 
	// bFl - the flag of clearing of memory 	 
	// Allocates memory under a file of a matrix 	 
	// At impossibility to allocate memory throws out exception such as a line
	// with a name error	
	LINKDLL CMatrix(int m, int n, bool bFl = true);

	// 
	//	     
	//	      ,
	//	  Create.

	//The Designer of a class 	 
	// the file under elements of a matrix is not allocated
	// For initialization it is necessary to use or operation of giving,
	// or function Create.
	LINKDLL CMatrix() {matr = NULL;}

	//
	//Destructor
	LINKDLL ~CMatrix()
	{
		if(bFlagDel)
			if(matr)
			{
				for (int i=0; i<n; i++)
					delete[] matr[i];
				delete matr;
			}
	}

	// 
	//	     
	//	m -   
	//	n -  
	//	bFl -   
	//	    
	//	       
	//	  error

	//The Initialization of a matrix
	// Is applied at use of the designer without parameters
	// m - number of columns matrixes
	// n - number of lines
	// bFl - flag of clearing of memory
	// Allocates memory under a file of a matrix
	// At impossibility to allocate memory throws out exception such as a line
	// with a name error
	LINKDLL void Create(int m, int n, bool bFl = true);

	//   
	//	str -  ,   
	//	column -  ,   
	//	x -  

	// Function of initialization of an element of a matrix
	// str - number of line, containing initialized element
 	// column - number of column, containing initialized element
 	// x - value of an element
	LINKDLL void Init(int str, int column, double x);

	//    
	//	     
	//	 .     .
	//  pResults -     

	//The Function of filling of a matrix of the initial data
	// Is used at processing experimental data by a method
	// of the least squares. Forms a matrix of initial system of the equations.
	// pResults - index on a file of results of gaugings
	LINKDLL void Form(double *pResults);

	//  
	//	  .
	//	   

	// the Function transposition of a matrix
	// returns the transposed matrix.
	// The initial matrix does not vary
	LINKDLL CMatrix Transp();

	//    
	//	  
	//	      
	//	  

	//The Function of account of the determinant of a square matrix
	// Returns value of the determinant
	// At attempt to find the determinant of a not square matrix the message
	// on a mistake is given out
	LINKDLL double Det();

	//   
	//	   

	//The Function of calculation of a rank of a matrix
	// returns size of a rank of a matrix
	LINKDLL int Rang();


	//       
	//	 
	//  sw -     
	//  res -    
	//       
	//	        
	//	  .
	//	     (   ),
	//	  NULL.

	//The Subroutine of the decision of system of the linear equations in the matrix form
	// by a method Gauss
	// sw - matrix a vector of the free members
	// res - index on a file of the decisions
	// The Subroutine returns the index on a file of the decisions
	// At attempt of application of function to a not square matrix the message
	// on a mistake is given out
	// At impossibility to find the unique(sole) decision (determinant of system is equal to zero),
	// the function returns NULL.
	LINKDLL double *Gauss(CMatrix &sw, double *res);

	//    
	// Redefinition of the operator of giving for matrixes
	LINKDLL CMatrix& operator = (const CMatrix &a);

	//      
	// Redefinition of the operator of multiplication of a matrix
	// on a vector
	LINKDLL CMatrix operator * (const double *b);

	//     
	// Redefinition of the operator of multiplication for matrixes
	LINKDLL CMatrix operator * (const CMatrix &b);

	//     
	// Redefinition of the operator of multiplication of a matrix on number
	LINKDLL CMatrix operator * (const double b);

	//   ==
	// Redefinition of the operator of comparison ==
	LINKDLL bool operator == (const CMatrix &b);

	//  +
	// Redefinition of the operator +
	LINKDLL CMatrix operator + (const CMatrix &b);

	//  -
	// Redefinition of the operator -
	LINKDLL CMatrix operator - (const CMatrix &b);

	protected:

	typedef struct TmpRez {int nNumRez; double Rez;} TRez;

	//  (  ) 
	//	       
	//	 .      
	//	      ,  , 
	//	  ,    ( 
	//	) .      .
	//	  ,    .
	//	      -  -1.   
	//	   (     
	//	).

	//The Sorting of elements (columns and lines) matrix
	// is used in functions of calculation of the determinant and decision of systems
	// of the linear equations. On each step of the circuit of unique(sole) division
	// changes the order of lines and columns of a matrix so that an element, on
	// which the division is made, had greatest possible (on absolute
	// to value) size. The maximal accuracy of calculations thus is provided.
	// Returns the whole value allowing to define(determine) a mark of the determinant.
	// If all elements of the current line zero - returns -1. In this case
	// the determinant is equal to zero (system of the linear equations has infinite number
	// of the decisions).
	int SortMatrix(CMatrix& m_Mtr, int i, CMatrix* p_sw = NULL, TRez* p_rez = NULL);

	// 
	//	     
	//	 :
	//	str  column -   ,     
	//	 
	//	Order -  
	//	m_Mtr -    

	//The Initialization minor
	// is used in function of calculation of a rank of a matrix
	//Transmitted parameters:
	// str and column - line and the column, on which crossing settles down first
	// an element minor
	// Order - order minor
	// m_Mtr - link to an initial matrix
	void InitMinor(int str, int column, int Order, CMatrix& m_Mtr);
};

	//    
	// :
	//     - n
	//     - m
	//       - rez[0]
	//       - rez[1]
	//        - pRatio
	//     
	// 

	//Function of approximation by a method of the least squares
	//Transmitted parameters:
	// Quantity(amount) of the carried out(spent) gaugings - n
	// Degree aproximating multinomial - m
	// The Index on a file of results of gaugings - rez[0]
	// The Index on a file of reference values - rez[1]
	// Pointer on array of factors aproximating multinomial - pRatio
	//Subroutine returns pointer on array of factors
	// aproximating multinomial
	LINKDLL double* Mnkm(int, int, double* rez[2], double* pRatio);

	//   
	//	ratio -     
	//	x -  ,     
	//	m -  
	//	  

	//Subroutine of calculation of importance of multinomial
 	// ratio - pointer on array of factors of multinomial
 	// x - importance of argument, for which is calculated importance of multinomial
 	// m - degree of multinomial
	//Returns importance of multinomial

	LINKDLL double Gorner(double* pRatio, double x, int m);
